-- ######################  CONFIGURATION ####################################

function MasterCommanderConfig_LoadVars()
	-- initialize our SavedVariable
	if ( not MasterCommanderConfig ) then 
	 	MasterCommanderConfig = {}; 
	end

	-- LOAD CHARACTER
	if ( not MasterCommanderConfig[MasterCommanderRealm] ) then 
	 	MasterCommanderConfig[MasterCommanderRealm] = {}; 
	end
	if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar] ) then 
	 	MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar] = {}; 
	end

	-- CHECK OPTIONS
	
	-- load each option, set default if not there
	
		-- Channel
		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].Channel ) then 
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].Channel = MasterCommander_Conf_Channel;
		end
		
		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].Channel2 ) then 
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].Channel2 = MasterCommander_Conf_Channel2;
		end		
		
		
		-- Warning messages
		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistAnnounceToRaid ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistAnnounceToRaid = MasterCommander_Conf_TauntResistAnnounceToRaid;
		end

		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistSayInRaid ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistSayInRaid = MasterCommander_Conf_TauntResistSayInRaid;
		end
		
		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistSayInSay ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistSayInSay = MasterCommander_Conf_TauntResistSayInSay;
		end

		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistPaladinChannel ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistPaladinChannel = MasterCommander_Conf_TauntResistPaladinChannel;
		end

		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistPaladinChannel2 ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistPaladinChannel2 = MasterCommander_Conf_TauntResistPaladinChannel2;
		end	
		
		

		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntedSayInRaid ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntedSayInRaid = MasterCommander_Conf_TauntedSayInRaid;
		end

		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntedSayInSay ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntedSayInSay = MasterCommander_Conf_TauntedSayInSay;
		end
		
		

		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].AvengerResistAnnounceToRaid ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].AvengerResistAnnounceToRaid = MasterCommander_Conf_AvengerResistAnnounceToRaid;
		end

		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].AvengerResistSayInRaid ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].AvengerResistSayInRaid = MasterCommander_Conf_AvengerResistSayInRaid;
		end
		
		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].AvengerResistSayInSay ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].AvengerResistSayInSay = MasterCommander_Conf_AvengerResistSayInSay;
		end

		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].AvengerResistPaladinChannel ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].AvengerResistPaladinChannel = MasterCommander_Conf_AvengerResistPaladinChannel;
		end

		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].AvengerResistPaladinChannel2 ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].AvengerResistPaladinChannel2 = MasterCommander_Conf_AvengerResistPaladinChannel2;
		end	
				

		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].AvengerPullMessageAnnounceToRaid ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].AvengerPullMessageAnnounceToRaid = MasterCommander_Conf_AvengerPullMessageAnnounceToRaid;
		end					
		
		
		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].CrusaderStrikeSayInSay ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].CrusaderStrikeSayInSay = MasterCommander_Conf_CrusaderStrikeSayInSay;
		end
		
		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].CrusaderStrikePaladinChannel ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].CrusaderStrikePaladinChannel = MasterCommander_Conf_CrusaderStrikePaladinChannel;
		end

		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].CrusaderStrikePaladinChannel2 ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].CrusaderStrikePaladinChannel2 = MasterCommander_Conf_CrusaderStrikePaladinChannel2;
		end	

		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].DivineInterventionAnnounceToRaid ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].DivineInterventionAnnounceToRaid = MasterCommander_Conf_DivineInterventionAnnounceToRaid;
		end		

		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].DivineInterventionSayInRaid ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].DivineInterventionSayInRaid = MasterCommander_Conf_DivineInterventionSayInRaid;
		end	

		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].DivineInterventionPaladinChannel ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].CrusaderStrikePaladinChannel = MasterCommander_Conf_DivineInterventionPaladinChannel;
		end	

		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].DivineInterventionPaladinChannel2 ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].CrusaderStrikePaladinChannel2 = MasterCommander_Conf_DivineInterventionPaladinChannel2;
		end			
		
		
		-- HUD Visibility		
		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].HudOutCombat ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].HudOutCombat = MasterCommander_Conf_HudOutCombat;
		end	

		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].HudInCombat ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].HudInCombat = MasterCommander_Conf_HudInCombat;
		end		
		
		

	-- read settings from profile, and change our checkbuttons and slider to represent them
	
		
	-- PALADIN CHANNEL
		PaladinChannel:SetText(MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].Channel);
		PaladinChannel2:SetText(MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].Channel2);
	
	-- WARNING MESSAGES
	
		TauntResistAnnounceToRaid:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistAnnounceToRaid );
		TauntResistSayInRaid:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistSayInRaid );
		TauntResistSayInSay:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistSayInSay );
		TauntResistPaladinChannel:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistPaladinChannel );
		TauntResistPaladinChannel2:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistPaladinChannel2 );	
			
		TauntedSayInRaid:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntedSayInRaid );
		TauntedSayInSay:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntedSayInSay );
		
		CrusaderStrikeSayInSay:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].CrusaderStrikeSayInSay );
		CrusaderStrikePaladinChannel:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].CrusaderStrikePaladinChannel );
		CrusaderStrikePaladinChannel2:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].CrusaderStrikePaladinChannel2 );	
			
		DivineInterventionAnnounceToRaid:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].DivineInterventionAnnounceToRaid );
		DivineInterventionSayInRaid:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].DivineInterventionSayInRaid );		
		DivineInterventionPaladinChannel:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].DivineInterventionPaladinChannel);
		DivineInterventionPaladinChannel2:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].DivineInterventionPaladinChannel2);	
		
		AvengerResistAnnounceToRaid:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistAnnounceToRaid );
		AvengerResistSayInRaid:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistSayInRaid );
		AvengerResistSayInSay:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistSayInSay );
		AvengerResistPaladinChannel:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistPaladinChannel );
		AvengerResistPaladinChannel2:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistPaladinChannel2 );	
		
		AvengerPullMessageAnnounceToRaid:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].AvengerPullMessageAnnounceToRaid );							
		
	-- HUD VISIBILITY
		HudInCombat:SetValue(MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].HudInCombat);
		HudOutCombat:SetValue(MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].HudOutCombat);																						
		

	-- record that we have been loaded
	MasterCommander_variablesLoaded = true;
	MasterCommanderConfig_Change();

end

 function MasterCommanderConfig_Change()

	-- check vars loaded
	if ( not MasterCommander_variablesLoaded ) then -- config not loaded
		ConfigFrame:Hide(); -- turn our mod off
		return;
	end
	
	-- make sure to use the frame's name here, cannot rely on 'this' to mean the main frame
	if ( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].on ) then
		ConfigFrame:Show(); -- show our mod frame
	else
		ConfigFrame:Hide(); -- hide our mod frame
	end
 end


-- ####################### HUD VISIBILITY ###################################

function SetHudVisibilityUp()
		
		local var_HudInCombat = HudInCombat:GetValue();
			if(var_HudInCombat == 0) then
				ProtectorFrame:Hide();
			else
				ProtectorFrame:Show();
				local var_HudInCombat2 = var_HudInCombat / 100;
				ProtectorFrame:SetAlpha(var_HudInCombat2);
			end		
end

function SetHudVisibilityDown()
		local var_HudOutCombat = HudOutCombat:GetValue();
			if(var_HudOutCombat == 0) then
				ProtectorFrame:Hide();
			else
				ProtectorFrame:Show();
				local var_HudOutCombat2 = var_HudOutCombat / 100;
				ProtectorFrame:SetAlpha(var_HudOutCombat2);
			end
end



Hud_UpdateInterval = 4;
function SetHudVisibilityUpdate(elapsed)
  TimeSinceLastUpdate2 = TimeSinceLastUpdate2 + elapsed; 	

  while (TimeSinceLastUpdate2 > Hud_UpdateInterval) do
    --
    -- Insert your OnUpdate code here
	
		if(InCombat == 0) then
			SetHudVisibilityDown();
		end

		if(InCombat == 1) then
			SetHudVisibilityUp();
		end		
   --

    TimeSinceLastUpdate2 = TimeSinceLastUpdate2 - Hud_UpdateInterval;
  end
end

	
				
-- ####################### ON LOAD EVENTS ###################################

function CheckAD_OnLoad()
	checkad = 0;

	local numTabs = GetNumTalentTabs();
	for t=1, numTabs do
		local numTalents = GetNumTalents(t);
		for i=1, numTalents do
			spell, icon, tier, column, currRank, maxRank= GetTalentInfo(2,20);  -- Tree 3 (protection), tier 19
		end
	end

	  if (spell == "Ardent Defender" and currRank > 0) then
		 checkad = 1;
	 end
		  
	return checkad;

end

function Check_SpellID(name)
	local i = 1
	while true do
	   local spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL)
	   if not spellName then
		  do break end
	   end
	   
	   if(spellName == name) then
			return i;
		end
	   
	   i = i + 1
	end
	
	
end


-- ####################### ON EVENT #############################
function MasterCommander_initialize()
	-- add our very first chat command!
	
	DEFAULT_CHAT_FRAME:AddMessage('** Master and Commander loaded. '.. Version_ ..' **');
	DEFAULT_CHAT_FRAME:AddMessage('** type /macconfig to open control panel **');
	DEFAULT_CHAT_FRAME:AddMessage('** |cffff0000-- Alpha version, contains only complete warning system, |r');
	DEFAULT_CHAT_FRAME:AddMessage('|cffff0000 and a protection test-hud --|r **');	
	
	
	-- slashcommands to start MasterCommander frames

	
	SlashCmdList["CONFIGURATION"] = MasterCommander_ShowConfigration;
	SLASH_CONFIGURATION1	= "/MasterAndCommander_Config";
	SLASH_CONFIGURATION2	= "/macconfig";
	
	SlashCmdList["CDANCE"] = MasterCommander_Dance;
	SLASH_CDANCE1 = "/cdance";
	SLASH_CDANCE2 = "/macdance";

	
end


 -- ------------------------------------------------
function out(text)
 UIErrorsFrame:AddMessage(text, 1.0, 1.0, 1.0, 1, 10) 
end

function out_error(text)
 UIErrorsFrame:AddMessage(text, 1.0, 0.0, 0, 1, 10) 
end


function MasterCommander_ShowConfigration()
   local frame = getglobal("ConfigFrame");
   if (frame) then
		 if(  frame:IsVisible() ) then
		   frame:Hide();
		else
			frame:Show();
		end
   end

end

function MasterCommander_Activation()

   local frame = getglobal("MasterCommanderFrame");
   if (frame) then
 	 if(  frame:IsVisible() ) then
   	   frame:Hide();
  	else
    	frame:Show();
  	end
   end


		-- Calculate percentage of the target's total health
		local max_health = UnitHealthMax("target");
		local current_health = UnitHealth("target");
		local health_now = math.ceil((100 / max_health) * current_health, 0);
		-- SendChatMessage('%T\'s health: ' .. health_now.. "%" , "SAY", nil, index); 
	
end




function SetPullUpdate()
-- checks if avenger's shield being fired. If so, and allright, go parse a message
	local spell, _, _, _, _, endTime = UnitCastingInfo("player")
	if spell then 
		if( string.find(spell, 'Avenger\'s Shield', 1))  then
			-- message
			if (UnitName("target")) then
				if not(UnitPlayerControlled("target")) then
					local var_AvengerPullMessageAnnounceToRaid = AvengerPullMessageAnnounceToRaid:GetChecked();	
					if(var_AvengerPullMessageAnnounceToRaid == 1) then
						if(UnitInParty("player") == 1) then
							SendChatMessage('**** Pulling '..UnitName("target")..' ****', "RAID_WARNING", nil, index); 
						end
					end	
				end
			end
		end
	end
end


-- ############ STATIC FUNCTIONS ##################### 





-- Spellcasting and return to enemy


-- ModelFrame updater
		function ModelFrame_OnEvent(hide)
		if not UnitExists("target") then
			ModelFrame:ClearModel();
		end

		ModelFrame:SetUnit("target");
		ModelFrame:SetAlpha(0.92);
		ModelFrame:SetScale(1);
		ModelFrame:SetCamera(0);
		ModelFrame:SetFacing(-45);
		ModelFrame:SetPosition(0,0,-1);
		ModelFrame:SetLight(1, 0, 0, -0.707, -0.707, 0.7, 1.0, 1.0, 1.0, 0.8, 1.0, 1.0, 0.8);

end






-- ######################## ON UPDATE EVENTS ############################### --

-- COMBAT MESSAGES

function Msg_Miss(arg1)
	if( string.find(arg1, "parry", 1))  then
		--DEFAULT_CHAT_FRAME:AddMessage('Parried!');
	end
	
	if( string.find(arg1, "dodge", 1))  then
		--DEFAULT_CHAT_FRAME:AddMessage('Dodged!');
	end
	
		if( string.find(arg1, "misses", 1))  then
		--DEFAULT_CHAT_FRAME:AddMessage('Missed!');
	end
	
	if( string.find(arg1, "BLOCK", 1))  then
		--DEFAULT_CHAT_FRAME:AddMessage('Blocked!');
	end
	
		if( string.find(arg1, "RESIST", 1))  then
		--DEFAULT_CHAT_FRAME:AddMessage('Resisted!');
	end
	
	

	
	
end

function Msg_MissEnemy(arg1)
	
	-- initialize paladin channel
	local var_PaladinChannel = PaladinChannel:GetText();
	local var_PaladinChannel2 = PaladinChannel2:GetText();
	
	-- initialize warnings	(crusader strike)
	local var_CrusaderStrikePaladinChannel = CrusaderStrikePaladinChannel:GetChecked();
	local var_CrusaderStrikePaladinChannel2 = CrusaderStrikePaladinChannel2:GetChecked();
	local var_CrusaderStrikeSayInSay = CrusaderStrikeSayInSay:GetChecked();
	
	-- initialize warnings	(righteous defense)
	local var_TauntResistAnnounceToRaid = TauntResistAnnounceToRaid:GetChecked();
	local var_TauntResistSayInRaid = TauntResistSayInRaid:GetChecked();	
	
	local var_TauntResistPaladinChannel = TauntResistPaladinChannel:GetChecked();
	local var_TauntResistPaladinChanne2 = TauntResistPaladinChannel2:GetChecked();
	local var_TauntResistSayInSay = TauntResistSayInSay:GetChecked();	
	
	local var_TauntedSayInRaid = TauntedSayInRaid:GetChecked();
	local var_TauntedSayInSay = TauntedSayInSay:GetChecked();

	local var_AvengerResistAnnounceToRaid = AvengerResistAnnounceToRaid:GetChecked();
	local var_AvengerResistSayInRaid = AvengerResistSayInRaid:GetChecked();
	local var_AvengerResistSayInSay = AvengerResistSayInSay:GetChecked();
	local var_AvengerResistPaladinChannel = AvengerResistPaladinChannel:GetChecked();
	local var_AvengerResistPaladinChannel2 = AvengerResistPaladinChannel2:GetChecked();
	
	
	-- Warnings
	
	cmissed = 0;
	missed = 0;
	spell1 = 'Crusader Strike';
	spell2 = 'Righteous Defense';
	spell3 = 'Avenger\'s Shield';
	
	if( string.find(arg1, spell1, 1))  then
		if( string.find(arg1, "resisted", 1))  then
			cmissed = 1;
		end
		if( string.find(arg1, "parried", 1))  then
			cmissed = 1;
		end
		if( string.find(arg1, "dodged", 1))  then
			cmissed = 1;
		end
		if( string.find(arg1, "missed", 1))  then
			cmissed = 1;
		end
		if( string.find(arg1, "immune", 1))  then
			cmissed = 1;
		end	
	else
		cmissed = 0;
	end	

	if( string.find(arg1, spell1, 1))  then
			if(cmissed == 1) then
				if(var_CrusaderStrikeSayInSay == 1) then
					SendChatMessage('Crusader Strike not applied!' , "SAY", nil, index);
				end
				if(var_CrusaderStrikePaladinChannel == 1) then
					local PalaChannel = GetChannelName(var_PaladinChannel) ;
					SendChatMessage('Crusader Strike not applied!' , "CHANNEL", nil, PalaChannel); 
				end					
			end
	end

	
	if( string.find(arg1, spell2, 1))  then
		if( string.find(arg1, "resisted", 1))  then
			missed = 1;
		end
		if( string.find(arg1, "parried", 1))  then
			missed = 1;
		end
		if( string.find(arg1, "dodged", 1))  then
			missed = 1;
		end
		if( string.find(arg1, "missed", 1))  then
			missed = 1;
		end	
		if( string.find(arg1, "immune", 1))  then
			missed = 1;
		end
	else
		missed = 0;
	end	
		
		
	if( string.find(arg1, spell2, 1))  then	
	

	
			if(missed == 1) then
				if(var_TauntResistAnnounceToRaid == 1) then
					SendChatMessage(UnitName("player").."'s taunt got resisted!" , "RAID_WARNING", nil, index); 
				end
				
				if(var_TauntResistSayInRaid == 1) then
					var_party = 0; 
					var_raid = 0;
					
					if(UnitInParty("player") == 1) then
						var_party = 1;			
							if(UnitInRaid("player") == 1) then
								var_raid = 1;
							end					
					end
					
					if(var_raid == 1) then
						SendChatMessage(UnitName("player").."'s taunt got resisted!" , "RAID", nil, index); 
					else
						if(var_party == 1) then
							SendChatMessage(UnitName("player").."'s taunt got resisted!" , "PARTY", nil, index); 
						end
					end						
				end	
				
				if(var_TauntResistSayInSay == 1) then
					SendChatMessage(UnitName("player").."'s taunt got resisted!" , "SAY", nil, index);
				end
				
				if(var_TauntResistPaladinChannel == 1) then
					local PalaChannel = GetChannelName(var_PaladinChannel) ;
					SendChatMessage(UnitName("player").."'s taunt resisted!" , "CHANNEL", nil, PalaChannel); 
				end	


				if(var_TauntResistPaladinChannel2 == 1) then
					local PalaChannel2 = GetChannelName(var_PaladinChannel2) ;
					SendChatMessage(UnitName("player").."'s taunt resisted!" , "CHANNEL", nil, PalaChannel2); 
				end									
			else


				string = string.sub(arg1, 30);
				
				if(var_TauntedSayInRaid == 1) then
					var_party = 0; 
					var_raid= 0;
					if(UnitInParty("player") == 1) then
						var_party = 1;			
							if(UnitInRaid("player") == 1) then
								var_raid = 1;
							end
					end
					
					
					
					if(var_raid == 1) then
						SendChatMessage(UnitName("player")..' has taunted'..string , "RAID", nil, index); 
					else
						if(var_party == 1) then
							SendChatMessage(UnitName("player")..' has taunted'..string , "PARTY", nil, index); 
						end
					end							
				end
				
				if(var_TauntedSayInSay == 1) then
					SendChatMessage(UnitName("player")..' has taunted'..string , "SAY", nil, index);
				end									
			end
	end
	
	if( string.find(arg1, spell3, 1))  then
		if( string.find(arg1, "resisted", 1))  then
			amissed = 1;
		end
		if( string.find(arg1, "parried", 1))  then
			amissed = 1;
		end
		if( string.find(arg1, "dodged", 1))  then
			amissed = 1;
		end
		if( string.find(arg1, "missed", 1))  then
			amissed = 1;
		end	
		if( string.find(arg1, "immune", 1))  then
			amissed = 1;
		end
	else
		amissed = 0;
	end	
	
			if(amissed == 1) then
		
			
				if(var_AvengerResistAnnounceToRaid == 1) then
					SendChatMessage('Avenger\'s Shield missed on '..UnitName("target") , "RAID_WARNING", nil, index); 
				end
				
				if(var_AvengerResistSayInRaid == 1) then
					var_party = 0; 
					var_raid = 0;
					
					if(UnitInParty("player") == 1) then
						var_party = 1;			
							if(UnitInRaid("player") == 1) then
								var_raid = 1;
							end					
					end
					
					if(var_raid == 1) then
						SendChatMessage(U'Avenger\'s Shield missed on '..UnitName("target") , "RAID", nil, index); 
					else
						if(var_party == 1) then
							SendChatMessage('Avenger\'s Shield is missed on '..UnitName("target"), "PARTY", nil, index); 
						end
					end						
				end	
				
				if(var_AvengerResistSayInSay  == 1) then
					SendChatMessage('Avenger\'s Shield is missed on '..UnitName("target") , "SAY", nil, index);
				end
				
				if(var_AvengerResistPaladinChannel == 1) then
					local PalaChannel = GetChannelName(var_PaladinChannel) ;
					SendChatMessage('Avenger\'s Shield is missed on '..UnitName("target") , "CHANNEL", nil, PalaChannel); 
				end	

				if(var_AvengerResistPaladinChannel2 == 1) then
					local PalaChannel2 = GetChannelName(var_PaladinChannel2) ;
					SendChatMessage('Avenger\'s Shield is missed on '..UnitName("target") , "CHANNEL", nil, PalaChannel2); 
				end													
			end		




end


function Msg_DivineIntervention(arg1)

	local var_DivineInterventionSayInRaid = DivineInterventionSayInRaid:GetChecked();
	local var_DivineInterventionAnnounceToRaid = DivineInterventionAnnounceToRaid:GetChecked();	
	local var_DivineInterventionPaladinChannel = DivineInterventionPaladinChannel:GetChecked();
	local var_DivineInterventionPaladinChannel2 = DivineInterventionPaladinChannel2:GetChecked();
	local var_PaladinChannel = PaladinChannel:GetText();
	local var_PaladinChannel2 = PaladinChannel2:GetText();

				
	if( string.find(arg1, "You cast Divine Intervention on", 1))  then
		local str_playername = string.sub(arg1, 32);
		
		if(var_DivineInterventionSayInRaid == 1) then
			var_party = 0; 
			var_raid= 0;
			if(UnitInParty("player") == 1) then
				var_party = 1;			
					if(UnitInRaid("player") == 1) then
						var_raid = 1;
					end
			end
			
			if(var_DivineInterventionAnnounceToRaid == 1) then
				SendChatMessage(UnitName("player")..' casted Divine Intervention on'..str_playername , "RAID_WARNING", nil, index); 
			end

			
			if(var_raid == 1) then
				SendChatMessage('Divine Intervention on'..str_playername , "RAID", nil, index); 
			else
				if(var_party == 1) then
					SendChatMessage('Divine Intervention on'..str_playername , "PARTY", nil, index); 
				end
			end							
		end
		
		if(var_DivineInterventionPaladinChannel == 1) then
			local PalaChannel = GetChannelName(var_PaladinChannel);
			SendChatMessage(UnitName("player")..' casted Divine Intervention on'..str_playername , "CHANNEL", nil, PalaChannel); 	
		end

		if(var_DivineInterventionPaladinChannel2 == 1) then
			local PalaChannel2 = GetChannelName(var_PaladinChannel2);
			SendChatMessage(UnitName("player")..' casted Divine Intervention on'..str_playername , "CHANNEL", nil, PalaChannel2); 	
		end		
	end	
end



-- library thingies

	-- PlaySound("PVPENTERQUEUE"); // Sound for successfull agro
	-- PlaySoundFile("Interface\\AddOns\\MasterCommander\sleep_rest.mp3");